diff --git a/src/ground_vehicle.cpp b/src/ground_vehicle.cpp
--- a/src/ground_vehicle.cpp
+++ b/src/ground_vehicle.cpp
@@ -15,6 +15,30 @@
 #include "vehicle_gui.h"
 #include "window_func.h"
 
+template <class T, VehicleType Type>
+void GroundVehicle<T, Type>::CalculatePower(uint32& total_power, uint32& max_te, bool breakdowns) const {
+
+	total_power = 0;
+	max_te = 0;
+    
+	const T *v = T::From(this);
+
+	for (const T *u = v; u != NULL; u = u->Next()) {
+		uint32 current_power = u->GetPower() + u->GetPoweredPartPower(u);
+		total_power += current_power;
+
+		/* Only powered parts add tractive effort. */
+		if (current_power > 0) max_te += u->GetWeight() * u->GetTractiveEffort();
+		
+		if (breakdowns && u->breakdown_ctr == 1 && u->breakdown_type == BREAKDOWN_LOW_POWER) {
+			total_power = total_power * u->breakdown_severity / 256;
+		}
+	}
+
+	max_te *= 10000; // Tractive effort in (tonnes * 1000 * 10 =) N.
+	max_te /= 256;   // Tractive effort is a [0-255] coefficient.
+}
+
 /**
  * Recalculates the cached total power of a vehicle. Should be called when the consist is changed.
  */
@@ -29,12 +53,9 @@
 	uint32 number_of_parts = 0;
 	uint16 max_track_speed = v->GetDisplayMaxSpeed();
 
+	this->CalculatePower(total_power, max_te, false);
+
 	for (const T *u = v; u != NULL; u = u->Next()) {
-		uint32 current_power = u->GetPower() + u->GetPoweredPartPower(u);
-		total_power += current_power;
-
-		/* Only powered parts add tractive effort. */
-		if (current_power > 0) max_te += u->GetWeight() * u->GetTractiveEffort();
 		number_of_parts++;
 
 		/* Get minimum max speed for this track. */
@@ -57,8 +78,6 @@
 
 	this->gcache.cached_air_drag = air_drag + 3 * air_drag * number_of_parts / 20;
 
-	max_te *= 10000; // Tractive effort in (tonnes * 1000 * 10 =) N.
-	max_te /= 256;   // Tractive effort is a [0-255] coefficient.
 	if (this->gcache.cached_power != total_power || this->gcache.cached_max_te != max_te) {
 		/* Stop the vehicle if it has no power. */
 		if (total_power == 0) this->vehstatus |= VS_STOPPED;
@@ -103,7 +122,7 @@
  * @return Current acceleration of the vehicle.
  */
 template <class T, VehicleType Type>
-int GroundVehicle<T, Type>::GetAcceleration() const
+int GroundVehicle<T, Type>::GetAcceleration()
 {
 	/* Templated class used for function calls for performance reasons. */
 	const T *v = T::From(this);
@@ -113,7 +132,8 @@
 	int32 mass = this->gcache.cached_weight;
 
 	/* Power is stored in HP, we need it in watts. */
-	int32 power = this->gcache.cached_power * 746;
+	uint32 power = this->gcache.cached_power * 746;
+	uint32 max_te = this->gcache.cached_max_te; // [N]
 
 	int32 resistance = 0;
 
@@ -134,13 +154,19 @@
 	/* This value allows to know if the vehicle is accelerating or braking. */
 	AccelStatus mode = v->GetAccelerationStatus();
 
-	const int max_te = this->gcache.cached_max_te; // [N]
+	/* Handle breakdown power reduction. */
+	if(  Type == VEH_TRAIN  && mode == AS_ACCEL && HasBit(Train::From(this)->flags, VRF_BREAKDOWN_POWER)) {
+		/* TODO: We'd like to cache this, but changing cached_power has too many unwanted side-effects. */
+		this->CalculatePower(power, max_te, true);
+		power *= 746;
+	}
+	
 	int force;
 	if (speed > 0) {
 		if (!maglev) {
 			/* Conversion factor from km/h to m/s is 5/18 to get [N] in the end. */
 			force = power * 18 / (speed * 5);
-			if (mode == AS_ACCEL && force > max_te) force = max_te;
+			if (mode == AS_ACCEL && force > (int)max_te) force = max_te;
 		} else {
 			force = power / 25;
 		}
@@ -150,6 +176,33 @@
 		force = max(force, (mass * 8) + resistance);
 	}
 
+	/* If power is 0 because of a breakdown, we make the force 0 if accelerating. */
+	if ( Type == VEH_TRAIN && mode == AS_ACCEL && HasBit(Train::From(this)->flags, VRF_BREAKDOWN_POWER) && power == 0) {
+		force = 0;
+	}
+
+	/* Calculate the breakdown chance. */
+	if (_settings_game.vehicle.improved_breakdowns) {
+		assert(this->gcache.cached_max_track_speed > 0);
+		/* First, calculate (resistance / force * current speed / max speed) << 16.
+		 * This yields a number x on a 0-1 scale, but shifted 16 bits to the left.
+		 * We then calculate 64 + 128x, clamped to 0-255, but still shifted 16 bits to the left.
+		 * Then we apply a correction for multiengine trains, and in the end we shift it 16 bits to the right to get a 0-255 number.
+		 * @note A seperate correction for multiheaded engines is done in CheckVehicleBreakdown. We can't do that here because it would affect the whole consist. */
+		uint64 breakdown_factor = (uint64)abs(resistance) * (uint64)(this->cur_speed << 16);
+		breakdown_factor /= (max(force, 100) * this->gcache.cached_max_track_speed);
+		breakdown_factor = min((64 << 16) + (breakdown_factor * 128), 255 << 16);
+		if ( Type == VEH_TRAIN && Train::From(this)->tcache.cached_num_engines > 1) {
+			/* For multiengine trains, breakdown chance is multiplied by 3 / (num_engines + 2). */
+			breakdown_factor *= 3;
+			breakdown_factor /= (Train::From(this)->tcache.cached_num_engines + 2);
+		}
+		/* Breakdown_chance is at least 5 (5 / 128 = ~4% of the normal chance). */
+		this->breakdown_chance = max(breakdown_factor >> 16, (uint64)5);
+	} else {
+		this->breakdown_chance = 128;
+	}
+
 	if (mode == AS_ACCEL) {
 		/* Easy way out when there is no acceleration. */
 		if (force == resistance) return 0;
@@ -160,7 +213,25 @@
 		 * a hill will never speed up enough to (eventually) get back to the
 		 * same (maximum) speed. */
 		int accel = (force - resistance) / (mass * 4);
-		return force < resistance ? min(-1, accel) : max(1, accel);
+		accel = force < resistance ? min(-1, accel) : max(1, accel);
+		if (this->type == VEH_TRAIN ) {
+			if(_settings_game.vehicle.train_acceleration_model == AM_ORIGINAL &&
+				HasBit(Train::From(this)->flags, VRF_BREAKDOWN_POWER)) {
+				/* We need to apply the power reducation for non-realistic acceleration here. */
+				CalculatePower(power, max_te, true);
+				accel = accel * power / this->gcache.cached_power;
+				accel -= this->acceleration >> 1;
+			}
+
+			if ( this->IsFrontEngine() && !(this->current_order_time & 0x1FF) &&
+				!(this->current_order.IsType(OT_LOADING)) &&
+				!(Train::From(this)->flags & (VRF_IS_BROKEN | (1 << VRF_TRAIN_STUCK))) &&
+				this->cur_speed < 3 && accel < 5) {
+				SetBit(Train::From(this)->flags, VRF_TO_HEAVY);
+			}
+		}
+
+		return accel;
 	} else {
 		return min(-force - resistance, -10000) / mass;
 	}
diff --git a/src/ground_vehicle.hpp b/src/ground_vehicle.hpp
--- a/src/ground_vehicle.hpp
+++ b/src/ground_vehicle.hpp
@@ -90,7 +90,8 @@
 
 	void PowerChanged();
 	void CargoChanged();
-	int GetAcceleration() const;
+	void CalculatePower(uint32& power, uint32& max_te, bool breakdowns) const;
+	int GetAcceleration();
 
 	/**
 	 * Common code executed for crashed ground vehicles
@@ -229,9 +230,9 @@
 	 * @param turned Indicates if the vehicle has turned.
 	 * @return Old height of the vehicle.
 	 */
-	FORCEINLINE byte UpdateInclination(bool new_tile, bool turned)
+	FORCEINLINE int32 UpdateInclination(bool new_tile, bool turned)
 	{
-		byte old_z = this->z_pos;
+		int32 old_z = this->z_pos;
 
 		if (new_tile) {
 			this->UpdateZPositionAndInclination();
@@ -367,7 +368,23 @@
 
 		/* When we are going faster than the maximum speed, reduce the speed
 		 * somewhat gradually. But never lower than the maximum speed. */
-		int tempmax = max_speed;
+		int tempmax = ((this->breakdown_ctr == 1) ? this->cur_speed : max_speed);
+
+		if (this->breakdown_ctr == 1) {
+			if (this->breakdown_type == BREAKDOWN_LOW_POWER) {
+				if((this->tick_counter & 0x7) == 0) {
+					if(this->cur_speed > (this->breakdown_severity * max_speed) >> 8) {
+						tempmax = this->cur_speed - (this->cur_speed / 10) - 1;
+					} else {
+						tempmax = (this->breakdown_severity * max_speed) >> 8;
+					}
+				}
+			}
+
+			if(this->breakdown_type == BREAKDOWN_LOW_SPEED)
+				tempmax = min(max_speed, this->breakdown_severity);
+		}
+
 		if (this->cur_speed > max_speed) {
 			tempmax = max(this->cur_speed - (this->cur_speed / 10) - 1, max_speed);
 		}
diff --git a/src/group_gui.cpp b/src/group_gui.cpp
--- a/src/group_gui.cpp
+++ b/src/group_gui.cpp
@@ -51,6 +51,7 @@
 	GRP_WIDGET_DELETE_GROUP,
 	GRP_WIDGET_RENAME_GROUP,
 	GRP_WIDGET_REPLACE_PROTECTION,
+	GRP_WIDGET_GROUP_INFO,
 };
 
 static const NWidgetPart _nested_group_widgets[] = {
@@ -71,6 +72,7 @@
 						SetFill(1, 0), SetResize(0, 1), SetScrollbar(GRP_WIDGET_LIST_GROUP_SCROLLBAR),
 				NWidget(NWID_VSCROLLBAR, COLOUR_GREY, GRP_WIDGET_LIST_GROUP_SCROLLBAR),
 			EndContainer(),
+			NWidget(WWT_PANEL, COLOUR_GREY, GRP_WIDGET_GROUP_INFO), SetMinimalSize(200, 25), SetFill(1, 1), EndContainer(),
 			NWidget(NWID_HORIZONTAL),
 				NWidget(WWT_PUSHIMGBTN, COLOUR_GREY, GRP_WIDGET_CREATE_GROUP), SetMinimalSize(24, 25), SetFill(0, 1),
 						SetDataTip(SPR_GROUP_CREATE_TRAIN, STR_GROUP_CREATE_TOOLTIP),
@@ -323,6 +325,40 @@
 		*this->sorting = this->vehicles.GetListing();
 	}
 
+	/** draw the group profit button in the group list window. */
+	virtual void DrawGroupProfitButton(int x, int y, GroupID gid, VehicleType vtype) const
+	{
+		Date max_age = 0;                                   ///< Age of the oldest vehicle in the group
+		Money this_year_profit = 0;                         ///< Total profit for the group this year
+		int vehicle_count = 0;                              ///< Vehicle count in the group
+
+		const Vehicle *v;
+		FOR_ALL_VEHICLES(v) {
+			if (v->owner == this->owner) {
+				if ((gid == ALL_GROUP  && v->type == vtype)|| v->group_id == gid) {
+					this_year_profit += v->GetDisplayProfitLastYear();
+					if (v->age > max_age) max_age = v->age;
+					vehicle_count++;
+				}
+			}
+		}
+
+		/* Draw button */
+		SpriteID spr;
+
+		/* draw profit-based coloured icons */
+		if (max_age <= DAYS_IN_YEAR * 2) {
+			spr = SPR_PROFIT_NA;
+		} else if (this_year_profit < 0) {
+			spr = SPR_PROFIT_NEGATIVE;
+		} else if (this_year_profit < 10000 * vehicle_count) {
+			spr = SPR_PROFIT_SOME;
+		} else {
+			spr = SPR_PROFIT_LOT;
+		}
+		DrawSprite(spr, PAL_NONE, x, y);
+	}
+
 	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
 	{
 		switch (widget) {
diff --git a/src/gui.h b/src/gui.h
--- a/src/gui.h
+++ b/src/gui.h
@@ -18,6 +18,7 @@
 #include "tile_type.h"
 #include "strings_type.h"
 #include "transport_type.h"
+#include "rail.h"
 
 struct Window;
 
@@ -45,9 +46,14 @@
 void ShowGenerateLandscape();
 void ShowHeightmapLoad();
 
+/* copy_paste_gui.cpp */
+void ShowCopyPasteToolbarGui();        // Using the buttons in terraform_gui.cpp
+void ShowCopyPasteToolbar(int button); // Using the shortcuts
+
 /* misc_gui.cpp */
 void ShowLandInfo(TileIndex tile);
 void ShowAboutWindow();
+void ShowSystemTimeWindow();
 void ShowBuildTreesToolbar();
 void ShowTownDirectory();
 void ShowIndustryDirectory();
diff --git a/src/heightmap.cpp b/src/heightmap.cpp
--- a/src/heightmap.cpp
+++ b/src/heightmap.cpp
@@ -361,8 +361,14 @@
 				assert(img_row < img_height);
 				assert(img_col < img_width);
 
-				/* Colour scales from 0 to 255, OpenTTD height scales from 0 to 15 */
-				SetTileHeight(tile, map[img_row * img_width + img_col] / 16);
+				/* Colour scales from 0 to 255, OpenTTD height scales from 0 to 15.
+				 * Heightlevelspatch scales according to terrain_type selected in difficulty settings.(0-255)
+				 * @see _max_heightmap_height[] in heightmap.h */
+				if (AllowMoreHeightlevels()) {
+					SetTileHeight(tile, map[img_row * img_width + img_col] / (_max_heightmap_height[_settings_game.difficulty.terrain_type]));
+				} else {
+					SetTileHeight(tile, map[img_row * img_width + img_col] / 16);
+				}
 			}
 			/* Only clear the tiles within the map area. */
 			if (TileX(tile) != MapMaxX() && TileY(tile) != MapMaxY() &&
@@ -390,7 +396,7 @@
 	/* Top and left edge */
 	for (row = 0; (uint)row < height; row++) {
 		for (col = 0; (uint)col < width; col++) {
-			current_tile = MAX_TILE_HEIGHT;
+			current_tile = GetMaxTileHeight();
 			if (col != 0) {
 				/* Find lowest tile; either the top or left one */
 				current_tile = TileHeight(TileXY(col - 1, row)); // top edge
@@ -412,7 +418,7 @@
 	/* Bottom and right edge */
 	for (row = height - 1; row >= 0; row--) {
 		for (col = width - 1; col >= 0; col--) {
-			current_tile = MAX_TILE_HEIGHT;
+			current_tile = GetMaxTileHeight();
 			if ((uint)col != width - 1) {
 				/* Find lowest tile; either the bottom and right one */
 				current_tile = TileHeight(TileXY(col + 1, row)); // bottom edge
diff --git a/src/heightmap.h b/src/heightmap.h
--- a/src/heightmap.h
+++ b/src/heightmap.h
@@ -21,6 +21,19 @@
 	HM_CLOCKWISE,         ///< Rotate the map clockwise 45 degrees
 };
 
+/** 
+ * Desired maximum height when generating a heightmap.
+ */
+static const uint8 _max_heightmap_height[7] = {
+64, ///< Fallen
+32, ///< Very flat
+16, ///< Flat
+8,  ///< Hilly
+4,  ///< Bumpy
+2,  ///< Mountainous
+1,  ///< Alpinist
+};
+
 bool GetHeightmapDimensions(char *filename, uint *x, uint *y);
 void LoadHeightmap(char *filename);
 void FlatEmptyWorld(byte tile_height);
diff --git a/src/industry_cmd.cpp b/src/industry_cmd.cpp
--- a/src/industry_cmd.cpp
+++ b/src/industry_cmd.cpp
@@ -39,6 +39,7 @@
 #include "subsidy_func.h"
 #include "core/backup_type.hpp"
 #include "object_base.h"
+#include "tgp.h"
 
 #include "table/strings.h"
 #include "table/industry_land.h"
@@ -1457,6 +1458,22 @@
 
 static bool CheckCanTerraformSurroundingTiles(TileIndex tile, uint height, int internal)
 {
+	/* Max. allowed delta when levelling land.
+	 * @see comment in industry_type.h for more information why we need this. */
+	uint max_delta;
+
+	if (_settings_game.game_creation.land_generator == LG_TERRAGENESIS && _generating_world) {
+		if (_settings_game.game_creation.tgen_smoothness == SMOOTHNESS_VERY_ROUGH) {
+			max_delta = IND_MAX_LEVELLING_VERY_ROUGH;
+		} else if (_settings_game.game_creation.tgen_smoothness == SMOOTHNESS_CEREALLY_ROUGH) {
+			max_delta = IND_MAX_LEVELLING_CEREALLY_ROUGH;
+		} else {
+			max_delta = IND_MAX_LEVELLING_NORMAL;
+		}
+	} else {
+		max_delta = IND_MAX_LEVELLING_NORMAL;
+	}
+
 	/* Check if we don't leave the map */
 	if (TileX(tile) == 0 || TileY(tile) == 0 || GetTileType(tile) == MP_VOID) return false;
 
@@ -1467,7 +1484,11 @@
 		if ((GetTileType(tile_walk) != MP_CLEAR) && (GetTileType(tile_walk) != MP_TREES)) return false;
 
 		/* Don't allow too big of a change if this is the sub-tile check */
-		if (internal != 0 && Delta(curh, height) > 1) return false;
+		uint8 IND_LEVELLING_MAX_HEIGHT  = _settings_game.construction.extra_industry_placement_logic; ///< Height limit for applying the extra logic.
+		if (internal != 0 && ((height < IND_LEVELLING_MAX_HEIGHT && Delta(curh, height) > max_delta)
+				||  (height >= IND_LEVELLING_MAX_HEIGHT && Delta(curh, height) > IND_MAX_LEVELLING_NORMAL))) {
+			return false;
+		}
 
 		/* Different height, so the surrounding tiles of this tile
 		 *  has to be correct too (in level, or almost in level)
diff --git a/src/industry_type.h b/src/industry_type.h
--- a/src/industry_type.h
+++ b/src/industry_type.h
@@ -33,4 +33,19 @@
 
 static const int INDUSTRY_COMPLETED = 3; ///< final stage of industry construction.
 
+/**
+ * When building a new industry, the game tries to level an appropriate place,
+ * if and only if there is no need to change the height of any tile by more
+ * than some given number of heightlevels. This number is defined here.
+ * Why do we need values > 1? Because when generating very rough maps, the game
+ * may run out of appropriate places for industries.
+ * And finally, to prevent industries at unrealistic heightlevels, we apply
+ * this extra logic only if we are below the heightlevel set in Advanced settings->Economy->Industries.
+ */
+enum IndustryMaxLevelling {
+	IND_MAX_LEVELLING_NORMAL         = 1,  ///< Usual behaviour
+	IND_MAX_LEVELLING_VERY_ROUGH     = 3,  ///< When generating a very rough map using TerraGenesis
+	IND_MAX_LEVELLING_CEREALLY_ROUGH = 4,  ///< When generating a cereally rough map using TerraGenesis
+};
+
 #endif /* INDUSTRY_TYPE_H */
diff --git a/src/infrastructure.cpp b/src/infrastructure.cpp
new file mode 100644
--- /dev/null
+++ b/src/infrastructure.cpp
@@ -0,0 +1,330 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file infrastructure.cpp Implementation of infrastructure sharing */
+
+#include "stdafx.h"
+#include "infrastructure_func.h"
+#include "train.h"
+#include "aircraft.h"
+#include "vehicle_func.h"
+#include "station_base.h"
+#include "depot_base.h"
+#include "pbs.h"
+#include "signal_func.h"
+#include "window_func.h"
+#include "gui.h"
+#include "pathfinder/yapf/yapf_cache.h"
+#include "company_base.h"
+
+#include "table/strings.h"
+
+/**
+ * Helper function for transferring sharing fees
+ * @param v The vehicle involved
+ * @param infra_owner The owner of the infrastructure
+ * @param cost Amount to transfer as money fraction (shifted 8 bits to the left)
+ */
+static void PaySharingFee(Vehicle *v, Owner infra_owner, Money cost)
+{
+	Company *c = Company::Get(v->owner);
+	if (!_settings_game.economy.sharing_payment_in_debt) {
+		/* Do not allow fee payment to drop (money - loan) below 0. */
+		cost = min(cost, (c->money - c->current_loan) << 8);
+		if (cost <= 0) return;
+	}
+	v->profit_this_year -= cost;
+	SubtractMoneyFromCompanyFract(v->owner, CommandCost(EXPENSES_SHARING_COST, cost));
+	SubtractMoneyFromCompanyFract(infra_owner, CommandCost(EXPENSES_SHARING_INC, -cost));
+}
+
+/**
+ * Pay the fee for spending a single tick inside a station.
+ * @param v The vehicle that is using the station.
+ * @param st The station that it uses.
+ */
+void PayStationSharingFee(Vehicle *v, const Station *st)
+{
+	if (v->owner == st->owner || st->owner == OWNER_NONE || v->type == VEH_TRAIN) return;
+	Money cost = _settings_game.economy.sharing_fee[v->type];
+	PaySharingFee(v, st->owner, (cost << 8) / DAY_TICKS);
+}
+
+/**
+ * Pay the daily fee for trains on foreign tracks.
+ * @param v The vehicle to pay the fee for.
+ */
+void PayDailyTrackSharingFee(Train *v)
+{
+	Owner owner = GetTileOwner(v->tile);
+	if (owner == v->owner) return;
+	Money cost = _settings_game.economy.sharing_fee[VEH_TRAIN] << 8;
+	/* Cost is calculated per 1000 tonnes */
+	cost = cost * v->gcache.cached_weight / 1000;
+	/* Only pay the required fraction */
+	cost = cost * v->running_ticks / DAY_TICKS;
+	if (cost != 0) PaySharingFee(v, owner, cost);
+}
+
+/**
+ * Check whether a vehicle is in an allowed position.
+ * @param v     The vehicle to check.
+ * @param owner Owner whose infrastructure is not allowed, because the company will be removed. Ignored if INVALID_OWNER.
+ * @return      True if the vehicle is compeletely in an allowed position.
+ */
+static bool VehiclePositionIsAllowed(const Vehicle *v, Owner owner = INVALID_OWNER)
+{
+	switch (v->type) {
+		case VEH_TRAIN:
+			for (const Vehicle *u = v; u != NULL; u = u->Next()) {
+				if (!IsInfraTileUsageAllowed(VEH_TRAIN, v->owner, u->tile) || GetTileOwner(u->tile) == owner) return false;
+			}
+			return true;
+		case VEH_ROAD:
+			for (const Vehicle *u = v; u != NULL; u = u->Next()) {
+				if (IsRoadDepotTile(u->tile) || IsStandardRoadStopTile(u->tile)) {
+					if (!IsInfraTileUsageAllowed(VEH_ROAD, v->owner, u->tile) || GetTileOwner(u->tile) == owner) return false;
+				}
+			}
+			return true;
+		case VEH_SHIP:
+			if (IsShipDepotTile(v->tile) && v->IsStoppedInDepot()) {
+				if (!IsInfraTileUsageAllowed(VEH_SHIP, v->owner, v->tile) || GetTileOwner(v->tile) == owner) return false;
+			}
+			return true;
+		case VEH_AIRCRAFT: {
+			const Aircraft *a = Aircraft::From(v);
+			if (a->state != FLYING && Station::IsValidID(a->targetairport)) {
+				Owner station_owner = Station::Get(a->targetairport)->owner;
+				if (!IsInfraUsageAllowed(VEH_AIRCRAFT, a->owner, station_owner) || station_owner == owner) return false;
+			}
+			return true;
+		}
+		default: return true;
+	}
+}
+
+/**
+ * Check whether an order has a destination that is allowed.
+ * I.e. it refers to a station/depot/waypoint the vehicle is allowed to visit.
+ * @param order The order to check
+ * @param v     The vehicle this order belongs to.
+ * @param owner Owner whose infrastructure is not allowed, because the company will be removed. Ignored if INVALID_OWNER.
+ * @return      True if the order has an allowed destination.
+ */
+static bool OrderDestinationIsAllowed(const Order *order, const Vehicle *v, Owner owner = INVALID_OWNER)
+{
+	Owner dest_owner;
+	switch (order->GetType()) {
+		case OT_GOTO_STATION:
+		case OT_GOTO_WAYPOINT: dest_owner = BaseStation::Get(order->GetDestination())->owner; break;
+		case OT_GOTO_DEPOT:    dest_owner = (v->type == VEH_AIRCRAFT) ? Station::Get(order->GetDestination())->owner : GetTileOwner(Depot::Get(order->GetDestination())->xy); break;
+		case OT_LOADING:       dest_owner = Station::Get(v->last_station_visited)->owner; break;
+		default: return true;
+	}
+	return dest_owner != owner && IsInfraUsageAllowed(v->type, v->owner, dest_owner);
+}
+
+/**
+ * Sell a vehicle, no matter where it may be.
+ * @param v The vehicle to sell
+ * @param give_money Do we actually need to give money to the vehicle owner?
+ */
+static void RemoveAndSellVehicle(Vehicle *v, bool give_money)
+{
+	assert(v->Previous() == NULL);
+
+	if (give_money) {
+		/* compute total value and give that to the owner */
+		Money value = 0;
+		for (Vehicle *u = v->First(); u != NULL; u = u->Next()) {
+			value += v->value;
+		}
+		CompanyID old = _current_company;
+		_current_company = v->owner;
+		SubtractMoneyFromCompany(CommandCost(EXPENSES_NEW_VEHICLES, -value));
+		_current_company = old;
+	}
+
+	/* take special measures for trains, but not when sharing is disabled or when the train is a free wagon chain */
+	if (_settings_game.economy.infrastructure_sharing[VEH_TRAIN] && v->type == VEH_TRAIN && Train::From(v)->IsFrontEngine()) {
+ 		DeleteVisibleTrain(Train::From(v));
+	} else {
+		delete v;
+	}
+}
+
+/**
+ * Check all path reservations, and reserve a new path if the current path is invalid.
+ */
+static void FixAllReservations()
+{
+	/* if this function is called, we can safely assume that sharing of rails is being switched off */
+	assert(!_settings_game.economy.infrastructure_sharing[VEH_TRAIN]);
+	Train *v;
+	FOR_ALL_TRAINS(v) {
+		if (!v->IsPrimaryVehicle() || (v->vehstatus & VS_CRASHED) != 0) continue;
+		/* It might happen that the train reserved additional tracks,
+		 * but FollowTrainReservation can't detect those because they are no longer reachable.
+		 * detect this by first finding the end of the reservation,
+		 * then switch sharing on and try again. If these two ends differ,
+		 * unreserve the path, switch sharing off and try to reserve a new path */
+		PBSTileInfo end_tile_info = FollowTrainReservation(v);
+
+		/* first do a quick test to determine whether the next tile has any reservation at all */
+		TileIndex next_tile = end_tile_info.tile + TileOffsByDiagDir(TrackdirToExitdir(end_tile_info.trackdir));
+		/* If the next tile doesn't have a reservation at all, the reservation surely ends here. Thus all is well */
+		if (GetReservedTrackbits(next_tile) == TRACK_BIT_NONE) continue;
+
+		/* change sharing setting temporarily */
+		_settings_game.economy.infrastructure_sharing[VEH_TRAIN] = true;
+		PBSTileInfo end_tile_info2 = FollowTrainReservation(v);
+		/* if these two reservation ends differ, unreserve the path and try to reserve a new path */
+		if (end_tile_info.tile != end_tile_info2.tile || end_tile_info.trackdir != end_tile_info2.trackdir) {
+			FreeTrainTrackReservation(v);
+			_settings_game.economy.infrastructure_sharing[VEH_TRAIN] = false;
+			TryPathReserve(v, true);
+		} else {
+			_settings_game.economy.infrastructure_sharing[VEH_TRAIN] = false;
+		}
+	}
+}
+
+/**
+ * Check if a sharing change is possible.
+ * If vehicles are still on others' infrastructure or using others' stations,
+ * The change is not possible and false is returned.
+ * @param type The type of vehicle whose setting will be changed.
+ * @return True if the change can take place, false otherwise.
+ */
+bool CheckSharingChangePossible(VehicleType type)
+{
+	if (type != VEH_AIRCRAFT) YapfNotifyTrackLayoutChange(INVALID_TILE, INVALID_TRACK);
+	/* Only do something when sharing is being disabled */
+	if (_settings_game.economy.infrastructure_sharing[type]) return true;
+
+	StringID error_message = STR_NULL;
+	Vehicle *v;
+	FOR_ALL_VEHICLES(v) {
+		if (type != v->type) continue;
+		if (v->Previous() != NULL) continue;
+
+		/* Check vehicle positiion */
+		if (!VehiclePositionIsAllowed(v)) {
+			error_message = STR_CONFIG_SETTING_SHARING_USED_BY_VEHICLES;
+			/* Break immediately, this error message takes precedence over the others. */
+			break;
+		}
+
+		/* Check current order */
+		if (!OrderDestinationIsAllowed(&v->current_order, v)) {
+			error_message = STR_CONFIG_SETTING_SHARING_ORDERS_TO_OTHERS;
+		}
+
+		/* Check order list */
+		if (v->FirstShared() != v) continue;
+		Order *o;
+		FOR_VEHICLE_ORDERS(v, o) {
+			if (!OrderDestinationIsAllowed(o, v)) {
+				error_message = STR_CONFIG_SETTING_SHARING_ORDERS_TO_OTHERS;
+			}
+		}
+	}
+
+	if (error_message != STR_NULL) {
+		ShowErrorMessage(error_message, INVALID_STRING_ID, WL_ERROR);
+		return false;
+	}
+
+	if (type == VEH_TRAIN) FixAllReservations();
+
+	return true;
+}
+
+/**
+ * Handle the removal (through reset_company or bankruptcy) of a company.
+ * i.e. remove all vehicles owned by that company or on its infrastructure,
+ * and delete all now-invalid orders.
+ * @param Owner the company to be removed.
+ */
+void HandleSharingCompanyDeletion(Owner owner)
+{
+	YapfNotifyTrackLayoutChange(INVALID_TILE, INVALID_TRACK);
+
+	Vehicle *v;
+	FOR_ALL_VEHICLES(v) {
+		if (!IsCompanyBuildableVehicleType(v) || v->Previous() != NULL) continue;
+		/* vehicle position */
+		if (v->owner == owner || !VehiclePositionIsAllowed(v, owner)) {
+			RemoveAndSellVehicle(v, v->owner != owner);
+			continue;
+		}
+		/* current order */
+		if (!OrderDestinationIsAllowed(&v->current_order, v, owner)) {
+			if (v->current_order.IsType(OT_LOADING)) {
+				v->LeaveStation();
+			} else {
+				v->current_order.MakeDummy();
+			}
+			SetWindowDirty(WC_VEHICLE_VIEW, v->index);
+		}
+
+		/* order list */
+		if (v->FirstShared() != v) continue;
+
+		Order *o;
+		int id = -1;
+		FOR_VEHICLE_ORDERS(v, o) {
+			id++;
+			if (OrderDestinationIsAllowed(o, v, owner)) continue;
+
+			o->MakeDummy();
+			for (const Vehicle *w = v; w != NULL; w = w->NextShared()) {
+				/* In GUI, simulate by removing the order and adding it back */
+				InvalidateVehicleOrder(w, id | (INVALID_VEH_ORDER_ID << 8));
+				InvalidateVehicleOrder(w, (id << 8) | INVALID_VEH_ORDER_ID);
+			}
+		}
+	}
+}
+
+/**
+ * Update all block signals on the map.
+ * To be called after the setting for sharing of rails changes.
+ * @param owner Owner whose signals to update. If INVALID_OWNER, update everything.
+ */
+void UpdateAllBlockSignals(Owner owner)
+{
+	Owner last_owner = INVALID_OWNER;
+	TileIndex tile = 0;
+	do {
+		if (IsTileType(tile, MP_RAILWAY) && HasSignals(tile)) {
+			Owner track_owner = GetTileOwner(tile);
+			if (owner != INVALID_OWNER && track_owner != owner) continue;
+
+			if (!IsOneSignalBlock(track_owner, last_owner)) {
+				/* Cannot update signals of two different companies in one run,
+				 * if these signal blocks are not joined */
+				UpdateSignalsInBuffer();
+				last_owner = track_owner;
+			}
+			TrackBits bits = GetTrackBits(tile);
+			do {
+				Track track = RemoveFirstTrack(&bits);
+				if (HasSignalOnTrack(tile, track)) {
+					AddTrackToSignalBuffer(tile, track, track_owner);
+				}
+			} while (bits != TRACK_BIT_NONE);
+		} else if (IsLevelCrossingTile(tile) && (owner == INVALID_OWNER || GetTileOwner(tile) == owner)) {
+			UpdateLevelCrossing(tile);
+		}
+	} while (++tile != MapSize());
+
+	UpdateSignalsInBuffer();
+}
